---
title: "Indexation"
weight: 13.5
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<p>L’indexation permet d’accéder aux éléments d’un vecteur selon leur ordre, ou leur nom</p>
<div id="indexation-par-lordre." class="section level3">
<h3>Indexation par l’ordre.</h3>
<pre class="r"><code>x=c(3,7,3,4,5)
x[1]</code></pre>
<pre><code>## [1] 3</code></pre>
<pre class="r"><code>x[1:2]</code></pre>
<pre><code>## [1] 3 7</code></pre>
<pre class="r"><code>x[-1]</code></pre>
<pre><code>## [1] 7 3 4 5</code></pre>
<ul>
<li><p>Exercice</p>
<ul>
<li>Afficher les noms du 4e et du 8e mois de l’année</li>
</ul></li>
</ul>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>month.name[c(4,8)]</code></pre>
<pre><code>## [1] &quot;April&quot;  &quot;August&quot;</code></pre>
<pre class="r"><code>month.name[rep(c(4,8),3)]</code></pre>
<pre><code>## [1] &quot;April&quot;  &quot;August&quot; &quot;April&quot;  &quot;August&quot; &quot;April&quot;  &quot;August&quot;</code></pre>
</details>
<hr />
</div>
<div id="indexation-par-un-vecteur-de-booléens" class="section level3">
<h3>Indexation par un vecteur de booléens</h3>
<pre class="r"><code>x=c(3,7,3,4,5)
x[c(F,T,F,F,T)]</code></pre>
<pre><code>## [1] 7 5</code></pre>
<pre class="r"><code>x[x%%2==1]</code></pre>
<pre><code>## [1] 3 7 3 5</code></pre>
<ul>
<li><p>Exercice</p>
<ul>
<li>Exécuter</li>
</ul></li>
</ul>
<pre class="r"><code>set.seed(1)
x=runif(1000)
y=runif(1000)
xplusgrand&lt;-(x&gt;y)</code></pre>
<pre><code>- Calculer les quartiles des valeurs de x lorsque x&gt;y</code></pre>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>quantile(x[xplusgrand],probs=c(0,.25,.5,.75,1))</code></pre>
<pre><code>##         0%        25%        50%        75%       100% 
## 0.02778712 0.47236106 0.70585901 0.86844803 0.99993059</code></pre>
</details>
<hr />
</div>
<div id="indexation-par-le-nomun-vecteur-de-booléens" class="section level3">
<h3>Indexation par le nomun vecteur de booléens</h3>
<p>On peut attribuer un nom à chaque élément d’un vecteur, et utiliser ces noms comme index:</p>
<pre class="r"><code>x&lt;-month.name
names(x)&lt;-letters[1:12]
names(x)</code></pre>
<pre><code>##  [1] &quot;a&quot; &quot;b&quot; &quot;c&quot; &quot;d&quot; &quot;e&quot; &quot;f&quot; &quot;g&quot; &quot;h&quot; &quot;i&quot; &quot;j&quot; &quot;k&quot; &quot;l&quot;</code></pre>
<pre class="r"><code>x[c(&quot;e&quot;,&quot;a&quot;,&quot;e&quot;)]</code></pre>
<pre><code>##         e         a         e 
##     &quot;May&quot; &quot;January&quot;     &quot;May&quot;</code></pre>
</div>
<div id="jongler-entre-les-index." class="section level3">
<h3>jongler entre les index.</h3>
<pre class="r"><code>x&lt;-month.name
names(x)&lt;-letters[1:12]
selection.i=c(1,4)
selection.b=is.element(1:12,selection.i)
selection.i2=which(selection.b)
selection.n=names(x)[selection.b]
selection.i3=which(is.element(names(x),selection.n))

x[selection.i]</code></pre>
<pre><code>##         a         d 
## &quot;January&quot;   &quot;April&quot;</code></pre>
<pre class="r"><code>x[selection.b]</code></pre>
<pre><code>##         a         d 
## &quot;January&quot;   &quot;April&quot;</code></pre>
<pre class="r"><code>x[selection.i2]</code></pre>
<pre><code>##         a         d 
## &quot;January&quot;   &quot;April&quot;</code></pre>
<pre class="r"><code>x[selection.n]</code></pre>
<pre><code>##         a         d 
## &quot;January&quot;   &quot;April&quot;</code></pre>
<pre class="r"><code>x[selection.i3]</code></pre>
<pre><code>##         a         d 
## &quot;January&quot;   &quot;April&quot;</code></pre>
</div>
